︠97eff9ec-3541-40d5-9410-0ac67241916dis︠
%hide
%md
## <span style='color:brown'> Vector </span>
### <span style='color:blue'> What is a vector?</span>
1. A geometric object that has magnitude (or length) and direction
2. Collection of variables!!

<br>

### <span style='color:red'> Vector only cares about the "difference" between the starting point and the end point </span>
︡a40dd26f-bcd9-45dc-a135-8fb7adb242b3︡{"hide":"input"}︡{"md":"## <span style='color:brown'> Vector </span>\n### <span style='color:blue'> What is a vector?</span>\n1. A geometric object that has magnitude (or length) and direction\n2. Collection of variables!!\n\n<br>\n\n### <span style='color:red'> Vector only cares about the \"difference\" between the starting point and the end point </span>"}︡{"done":true}
︠c4f2b15d-188d-4f3b-b1b4-4e08b6d0f6cbsi︠
%hide
v1 = vector([1,3])

fig1 = plot(v1)
point1 = text('(0,0)',(0,0.2))
point2 = text('(1,3)',(1.1,3))
fig1+point1+point2
︡16b3b1a5-e0a6-45c4-ac96-588259dc6d8b︡{"hide":"input"}︡{"file":{"filename":"/home/user/.sage/temp/project-abb83c66-a9f1-488b-80bd-fd40b9e4a2fc/663/tmp_x__Luc.svg","show":true,"text":null,"uuid":"71682519-5190-42cf-a8da-e3dd5deb7b00"},"once":false}︡{"done":true}
︠4cd17c6f-3ef3-4645-8c4c-7242f88a410ais︠
%hide
%md
## <span style = 'color:red'>Why we need it here? </span>
## => We can use vector to describe current variables!!!

︡16daa853-b7c0-4048-b2a3-9beb87d02c4f︡{"hide":"input"}︡{"md":"## <span style = 'color:red'>Why we need it here? </span>\n## => We can use vector to describe current variables!!!"}︡{"done":true}
︠f88a0204-dab8-4e19-b726-8fea11c5eaf1is︠
%hide
%latex
\begin{flushleft}
$\gamma(t_1) = \begin{bmatrix}x(t_1)\\y(t_1)\\z(t_1)\end{bmatrix}$\\
$\gamma$ can be our new state "vector"\\
We can simplify our equations of the system to:\\\
$\dot{\gamma} = f(\gamma)$
\end{flushleft}
︡be15ce70-2d5d-4041-b36e-e8dcda6aaf75︡{"hide":"input"}︡{"file":{"filename":"/tmp/tmp9ltltT.png","show":true,"text":null,"uuid":"fe570581-ac18-4f9e-baed-61dbbdad4d58"},"once":false}︡{"done":true}
︠68580f47-c713-4df3-94c5-d8440b6f54e8si︠

%hide
%md
## <span style='color:brown'>How to create vector in Sage </span>
︡7750e275-bddd-4cbf-acae-7f249e01a652︡{"hide":"input"}︡{"md":"## <span style='color:brown'>How to create vector in Sage </span>"}︡{"done":true}
︠96315c36-92d8-49bb-a5b5-4d1ca209cde9s︠
'how we define vectors'
v1= vector([1,2])
v2 = vector([3,-3])
v1
v2
'math operation on vectors'
v1+v2
3*v1
v2/3
'retrieve each variable'
v1[0]
v2[1]

︡b0054c0a-a525-44a9-b162-66d9cacb3227︡{"stdout":"'how we define vectors'\n"}︡{"stdout":"(1, 2)\n"}︡{"stdout":"(3, -3)\n"}︡{"stdout":"'math operation on vectors'\n"}︡{"stdout":"(4, -1)\n"}︡{"stdout":"(3, 6)\n"}︡{"stdout":"(1, -1)\n"}︡{"stdout":"'retrieve each variable'\n"}︡{"stdout":"1\n"}︡{"stdout":"-3\n"}︡{"done":true}
︠c82f2034-d269-4882-b036-03ea6c5a5012is︠
%hide
%md
## <span style='color:brown'> How to plot them? </span>
︡75328c5b-d3ee-4775-85b7-36a517d3f030︡{"hide":"input"}︡{"md":"## <span style='color:brown'> How to plot them? </span>"}︡{"done":true}
︠e620e5cc-1970-42ff-b033-dcac4daf6b0cs︠
fig1 = plot(v1)
fig2 = plot(v2)
fig3 = plot(v1+v2,color='red')

#please ignore the following lines
fig4 = arrow(v1,v1+v2,color='green') # just for showing parallel v2
fig1+fig2+fig3+fig4
︡d3a684c2-cb68-4f5d-96e2-6301b4570faa︡{"file":{"filename":"/home/user/.sage/temp/project-abb83c66-a9f1-488b-80bd-fd40b9e4a2fc/1114/tmp_XU6Dil.svg","show":true,"text":null,"uuid":"25ea16d5-c513-4780-8c1c-ddcf32306e25"},"once":false}︡{"done":true}
︠80d68e25-6dbf-4b17-ae5b-a599f4f77613is︠
%hide
%md
### <span style='color:red'>We can also plot in 3D </span>

︡cff77714-b5ef-4d66-b025-f742855ef0a3︡{"hide":"input"}︡{"md":"### <span style='color:red'>We can also plot in 3D </span>"}︡{"done":true}
︠633a80a0-add0-4f60-b502-fc747375d77bs︠
v3d = vector([1,3,4])
plot(v3d)
︡d184ac8f-350d-4c92-85b5-d64f4abe93b2︡{"file":{"filename":"e0e4250f-1fab-4b7a-ac28-3f860551856b.sage3d","uuid":"e0e4250f-1fab-4b7a-ac28-3f860551856b"}}︡{"done":true}
︠3fc8adea-c206-4f36-bbac-bd16e79a4c86is︠

%hide
%md
## <span style='color:brown'> Linear Function </span>
<br>
︡9ba64254-79b9-485f-98f1-78199db15703︡{"hide":"input"}︡{"md":"## <span style='color:brown'> Linear Function </span>\n<br>"}︡{"done":true}
︠cf184256-c5a1-4979-9ce3-c6763c0127e1si︠
%hide
%latex
\begin{flushleft}
For any a,b are real constant\\
$f(ax+by)=af(x)+bf(y)$\\
Which of the following function is linear?

(a)$f(\begin{bmatrix}x\\y\end{bmatrix})=a\dot{x}+bx+cy$\\
(b)$f(\begin{bmatrix}x\\y\end{bmatrix})=x^2+y$\\
(c)$f(\begin{bmatrix}x\\y\end{bmatrix})=ax+by+1$\\
(d)$f(\begin{bmatrix}x\\y\end{bmatrix})=sin(x)+cos(y)$\\
\end{flushleft}
︡705b1f44-e05b-4e5c-95bc-2e19a1effceb︡{"hide":"input"}︡{"file":{"filename":"/tmp/tmpyP91yv.png","show":true,"text":null,"uuid":"ab5df932-9755-46e9-b28d-31050bb23182"},"once":false}︡{"done":true}
︠9968d08d-ba73-495b-b15d-c5b246d2f4f5is︠
%hide
%md
<br><br><br>
Answer: (a)
︡d1a32ef9-3a4c-4f61-9ddb-6777e4f157da︡{"hide":"input"}︡{"md":"<br><br><br>\nAnswer: (a)"}︡{"done":true}
︠46c0f5c3-1fb2-47a9-b9f1-386760afec04si︠
%hide
%latex
\begin{flushleft}
$\frac{d(x_1+x_2)}{dt}=\lim_{\triangle t\rightarrow 0} \frac{x(t_1+\triangle t)-x(t_1)+x(t_2+\triangle t)-x(t_2)}{\triangle t} =\dot{x_1}+\dot{x_2}$\\


Example:\\
Suppose $x(t) = 3e^{2t},f(x) = \dot{x}+5x,x_1=x(t_1),x_2=x(t_2)$\\
$f(x_1) = 6e^{2t_1}+15e^{2t_1}=21e^{2t_1}$\\
$f(x_2) = 6e^{2t_2}+15e^{2t_2}=21e^{2t_2}$\\
$f(x_1+x_2)=\dot{x_1}+\dot{x_2}+5(x_1+x_2) = 42e^{2t_1}$
\end{flushleft}
︡124da5bf-7247-42b7-86ba-6b2901769944︡{"hide":"input"}︡{"file":{"filename":"/tmp/tmpj0i84L.png","show":true,"text":null,"uuid":"db7d3dbe-5a7e-4922-811e-74c642a71f7e"},"once":false}︡{"done":true}
︠b56491f9-b2ae-4629-bd3c-0e2b93029af1is︠
%hide
%md
## <span style='color:red'>Hint for today's lab</span>
In today's lab, it requires you to write a function for determining whether a function is linear

Hint: Compare two symbolic equations
︡a4ce3f6b-13d4-4c16-b2e9-84e02922cad1︡{"hide":"input"}︡{"md":"## <span style='color:red'>Hint for today's lab</span>\nIn today's lab, it requires you to write a function for determining whether a function is linear\n\nHint: Compare two symbolic equations\n"}︡{"done":true}
︠80d9111b-4a72-478f-a9b0-5ef86779f6c4s︠

def testFun(x):
    return vector([x[0]*0.25+x[1]*1.3,x[0]*1.2+x[1]*0.3])
x1 = vector([1,3])
y1 = testFun(x1)
x2 = vector([3,2.5])
y2 = testFun(x2)
x3 = vector([4,5.5])
y3 = testFun(x3)
︡12ed0e6b-feff-4ea8-a274-9f57e7f64233︡{"done":true}
︠c257dbce-4254-4484-8c40-6d903db1a04fs︠
plot(x1,color='red')+plot(y1,color='red',linestyle='--')+plot(x2,color='blue')+plot(y2,color='blue',linestyle='--')+plot(x3,color='green')+plot(y3,color='green',linestyle='--')
︡32e141d9-1ddb-4ef8-9bb5-2c6759d9d3fc︡{"file":{"filename":"/home/user/.sage/temp/project-abb83c66-a9f1-488b-80bd-fd40b9e4a2fc/96/tmp_I73uYs.svg","show":true,"text":null,"uuid":"45ce98c8-f0bb-4fc4-877b-05689399e0ea"},"once":false}︡{"done":true}
︠a0a4033a-07f6-4ab3-ab0a-4672a07a7e97︠
pp









